#pragma once
/*
 *  Material.h
 *  Hubschrauber
 *
 *  Created by Torsten on 11.04.07.
 *  Copyright 2007 __MyCompanyName__. All rights reserved.
 *
 */

#include <vector>

namespace Res
{
class HBSCMesh;
}

namespace Net
{
class ReadDataStream;
class WriteDataStream;
}

namespace OS
{
class Path;
}

namespace XML
{
class Document;
class Element;
}

namespace Gra
{
class Renderer;

class MaterialObject
{
	public:
	virtual unsigned GetGroupTexture(unsigned group, unsigned textureNumber) = 0;
	virtual ~MaterialObject() {}
};

class Material
{
	public:
	
	class Technic
	{
		protected:
		float difficulty;
		bool renderAtAll;
		
		void *program;
		Renderer *renderer;
		bool isSupported;
		
		unsigned textureCount;
		struct Texture
		{
			enum
			{
				CubeMap = -1,
				NormalisationMap = -2
			};
			int index; // Values > 0 are defined by the model, values < 0 are global constants
			int combinerMode;
		} *textures;
		Technic() {}
		
		public:
		
		Technic(Net::ReadDataStream &stream, OS::Path *path, Renderer *renderer);
		Technic(XML::Element &element, OS::Path *path, Renderer *renderer);
		
		bool IsSupported() { return isSupported; }
		float GetDifficulty() const { return difficulty; }
		bool RendersAtAll() const { return renderAtAll; }
		void SetupState();
		void SetupGroupState(MaterialObject *mesh, unsigned forGroup);
		void TearDownState();
		
		void *GetProgramHandle() { return program; }
	};
	
	protected:
	
	std::vector<Technic *> techniques;
	
	Technic *usedTechnic;
	
	void Load(XML::Document &document, OS::Path *path, Renderer *renderer);
	void Load(Net::ReadDataStream &stream, OS::Path *path, Renderer *renderer);
	
	Material() {}
	
	public:
	
	Material(OS::Path *path, Renderer *renderer);
	void CalculateUsedTechnic(float maxDifficulty);
	Technic *GetUsedTechnic() { return usedTechnic; }
	void SetUniform(const char *name, float value1);
	void SetUniform(const char *name, float value1, float value2);
	void SetUniform(const char *name, float value1, float value2, float value3);
	void SetUniform(const char *name, float value1, float value2, float value3, float value4);
};

}